# counter.py
# simple tool class that implements a counter that would be used to count attendance
# at a basketball game, or a dance.


class Counter:

    def __init__(self, start_value=0):
        self.__start_value = start_value
        self.__value = start_value

    def reset(self):
        self.__value = self.__start_value

    def get_value(self):
        return self.__value

    def click(self):
        self.__value += 1

    def __str__(self):
        message = []
        message.append("Counter:")
        message.append("[value =")
        message.append(str(self.__value) + "]")
        message.append("[start_value =")
        message.append(str(self.__start_value) + "]")
        return " ".join(message)


def main():
    print("class Counter unit test output follows:")

    print("\nTest case 1: Construct a counter with no initial value passed as parameter")
    c1 = Counter()
    expected = 0
    actual = c1.get_value()
    if actual == expected:
        print("Passed")
    else:
        print("Failed")

    print("\nTest case 2: Construct a counter with an initial value of 250")
    c1 = Counter(250)
    expected = 250
    actual = c1.get_value()
    if actual == expected:
        print("Passed")
    else:
        print("Failed")

    print("\nTest case 3: test click() method")
    c1 = Counter(250)
    c1.click()
    c1.click()
    expected = 252
    actual = c1.get_value()
    if actual == expected:
        print("Passed")
    else:
        print("Failed")

    print("\nTest case 4: test reset() method")
    c1 = Counter(250)
    c1.click()
    c1.click()
    c1.reset()
    expected = 250
    actual = c1.get_value()
    if actual == expected:
        print("Passed")
    else:
        print("Failed")

    print("\nTest case 5: test __str()__ method")
    c1 = Counter(250)
    c1.click()
    c1.click()
    actual = str(c1)
    expected = "Counter: [value = 252] [start_value = 250]"
    if actual == expected:
        print("Passed")
    else:
        print("Failed")


if __name__ == '__main__':
    main()
